//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// DownloadListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "DownloadListCtrl.h"
#include "otherfunctions.h" 
#include "updownclient.h"
#include "opcodes.h"
#include "ClientDetailDialog.h"
#include "FileDetailDialog.h"

#define DLC_DT_TEXT (DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX|DT_END_ELLIPSIS)

#define DLC_BARUPDATE 512

//temp fix for dragging columns
#define SetExtendedStyle(X) (CListCtrl::SetExtendedStyle(X))

// CDownloadListCtrl

// hmm some parts here might be overkill ;) ...
// oh well at least I can do/draw/paint everything I want in this window now ;)

IMPLEMENT_DYNAMIC(CDownloadListCtrl, CListBox)
CDownloadListCtrl::CDownloadListCtrl() {
	m_CurrentSortItem = 0;
	m_SortAscending = FALSE;
}

CDownloadListCtrl::~CDownloadListCtrl(){

	for (POSITION pos = listcontent.GetHeadPosition();pos != 0;listcontent.GetNext(pos))
		delete listcontent.GetAt(pos);
}

void CDownloadListCtrl::Init(){
	CImageList ilDummyImageList; //dummy list
	ilDummyImageList.Create(1, 17,ILC_COLOR, 1, 1); 
	SetImageList(&ilDummyImageList, LVSIL_SMALL);
	SetStyle();
	SetColors();

	ModifyStyle(LVS_SINGLESEL,0);

	InsertColumn(0,GetResString(IDS_DL_FILENAME),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(0));
	InsertColumn(1,GetResString(IDS_DL_SIZE),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(1));
	InsertColumn(2,GetResString(IDS_DL_TRANSF),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(2));
	InsertColumn(3,GetResString(IDS_DL_SPEED),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(3));
	InsertColumn(4,GetResString(IDS_DL_PROGRESS),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(4));
	InsertColumn(5,GetResString(IDS_DL_SOURCES),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(5));
	InsertColumn(6,GetResString(IDS_PRIORITY),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(6));
	InsertColumn(7,GetResString(IDS_STATUS),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(7)); 
	InsertColumn(8,GetResString(IDS_DL_REMAINS),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(8)); 

	m_ImageList.Create(15,15,ILC_COLOR32|ILC_MASK,0,10);
	m_ImageList.SetBkColor(CLR_NONE);
	m_ImageList.Add(theApp.LoadIcon(IDI_DCS1));
	m_ImageList.Add(theApp.LoadIcon(IDI_DCS2));
	m_ImageList.Add(theApp.LoadIcon(IDI_DCS3));
	m_ImageList.Add(theApp.LoadIcon(IDI_DCS4));
	m_ImageList.Add(theApp.LoadIcon(IDI_DCS5));
	m_ImageList.Add(theApp.LoadIcon(IDI_COMPPROT));

	CreateMenues();
}

void CDownloadListCtrl::Localize() {
	CHeaderCtrl* pHeaderCtrl = GetHeaderCtrl();
	HDITEM hdi;
	hdi.mask = HDI_TEXT;
	CString strRes;

	strRes = GetResString(IDS_DL_FILENAME);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(0, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_DL_SIZE);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(1, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_DL_TRANSF);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(2, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_DL_SPEED);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(3, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_DL_PROGRESS);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(4, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_DL_SOURCES);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(5, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_PRIORITY);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(6, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_STATUS);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(7, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_DL_REMAINS);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(8, &hdi);
	strRes.ReleaseBuffer();
}

void CDownloadListCtrl::AddFile(CPartFile* toadd){
        CtrlItem_Struct* newitem = new CtrlItem_Struct;
        uint16 itemnr = GetItemCount();
        newitem->owner = 0;
        newitem->type = 1;
        newitem->value = toadd;
        newitem->parent = NULL;
		newitem->dwUpdated = false; 
        listcontent.AddTail(newitem);
        InsertItem(LVIF_PARAM,itemnr,0,0,0,0,(LPARAM)newitem);
}

void CDownloadListCtrl::AddSource(CPartFile* owner,CUpDownClient* source,bool notavailable){
        
        CtrlItem_Struct* newitem = new CtrlItem_Struct;
        newitem->owner = owner;
        newitem->type = (notavailable)? 3:2;
        newitem->value = source;
		newitem->dwUpdated = false; 

        listcontent.AddTail(newitem);

        CtrlItem_Struct* search = 0;
        for (POSITION pos = listcontent.GetHeadPosition();pos != 0;listcontent.GetNext(pos)){
                if (listcontent.GetAt(pos)->value == owner){
                        search = listcontent.GetAt(pos);
                        break;
                }
        }
        newitem->parent = search;

        if (!owner->srcarevisible)
                return;

        LVFINDINFO find;
        find.flags = LVFI_PARAM;
        find.lParam = (LPARAM)search;
        uint16 itemnr = FindItem(&find);
        while (GetItemCount() > itemnr+1 && ((CtrlItem_Struct*)GetItemData(itemnr+1))->type != 1)
                itemnr++;
        InsertItem(LVIF_PARAM,itemnr+1,0,0,0,0,(LPARAM)newitem);
}


void CDownloadListCtrl::RemoveSource(CUpDownClient* source,CPartFile* owner){
   POSITION pos1, pos2;
   for( pos1 = listcontent.GetHeadPosition(); ( pos2 = pos1 ) != NULL; ){
	   listcontent.GetNext(pos1);
	   CtrlItem_Struct* delitem = listcontent.GetAt(pos2);
	   if(delitem->value == source && (delitem->owner == owner || (!owner) ) ){
 			LVFINDINFO find;
			find.flags = LVFI_PARAM;
			find.lParam = (LPARAM)delitem;
			sint16 result = FindItem(&find);
			if (result != (-1))
				DeleteItem(result);
			listcontent.RemoveAt(pos2);
			delitem->status.DeleteObject();
			delete delitem;
       }
   }
}

void CDownloadListCtrl::RemoveFile(CPartFile* toremove){
   POSITION pos1, pos2;
   for( pos1 = listcontent.GetHeadPosition(); ( pos2 = pos1 ) != NULL; ){
	   CtrlItem_Struct* delitem = listcontent.GetNext(pos1);    
	   if(delitem->value == toremove){
 			LVFINDINFO find;
			find.flags = LVFI_PARAM;
			find.lParam = (LPARAM)delitem;
			sint16 result = FindItem(&find);
			if (result != -1)
				DeleteItem(result);
			listcontent.RemoveAt(pos2);
			delitem->status.DeleteObject();
			delete delitem;
       }
   }
}

void CDownloadListCtrl::UpdateItem(void* toupdate){
	CtrlItem_Struct* search = 0;
	for (POSITION pos = listcontent.GetHeadPosition();pos !=  0;listcontent.GetNext(pos)){
		if (listcontent.GetAt(pos)->value == toupdate){
			search = listcontent.GetAt(pos);
			LVFINDINFO find;
			find.flags = LVFI_PARAM;
			find.lParam = (LPARAM)search;
			sint16 result = FindItem(&find);
			if (result != -1){
				search->dwUpdated = 0;
				Update(result);
			}
			return;
		}
	}
}

void CDownloadListCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct){
	if (!lpDrawItemStruct->itemData)
		return;

	CDC* odc = CDC::FromHandle(lpDrawItemStruct->hDC);
	CtrlItem_Struct* content = (CtrlItem_Struct*)lpDrawItemStruct->itemData;
	BOOL bCtrlFocused = ((GetFocus() == this) || (GetStyle() & LVS_SHOWSELALWAYS));

	if ((content->type == 1) && (lpDrawItemStruct->itemAction | ODA_SELECT) &&
	    (lpDrawItemStruct->itemState & ODS_SELECTED)) {

		if(bCtrlFocused)
			odc->SetBkColor(m_crHighlight);
		else
			odc->SetBkColor(m_crNoHighlight);

	} /*else if (content->type != 1) {
		COLORREF crHighlight = m_crWindowText;
		COLORREF crWindow = m_crWindow;
		COLORREF crHalf = DLC_RGBBLEND(crHighlight, crWindow, 16);
		odc->SetBkColor(crHalf);
	}*/ else
		odc->SetBkColor(GetBkColor());

	CMemDC dc(odc,&CRect(lpDrawItemStruct->rcItem));
	dc->SelectObject(GetFont());
	dc->SetTextColor(m_crWindowText);

	BOOL notLast = lpDrawItemStruct->itemID + 1 != GetItemCount();
	BOOL notFirst = lpDrawItemStruct->itemID != 0;
	int tree_start;
	int tree_end;

	RECT cur_rec;
	memcpy(&cur_rec,&lpDrawItemStruct->rcItem,sizeof(RECT));

	if (content->type == 1){
		CPartFile* partfile = (CPartFile*)content->value;

		char buffer[200];char buffer2[20];
		// file name
		cur_rec.right = cur_rec.left + GetColumnWidth(0);
		cur_rec.left += 4;
		dc->DrawText(partfile->GetFileName(),(int)strlen(partfile->GetFileName()),&cur_rec, DLC_DT_TEXT);
		//size
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(1);
		CastItoXBytes(partfile->GetFileSize(),buffer);
		dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DLC_DT_TEXT);
		// transfered
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(2);
		CastItoXBytes(partfile->GetTransfered(),buffer);
		dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DLC_DT_TEXT);	
		// speed
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(3);
		if (partfile->GetTransferingSrcCount()==0)
			sprintf(buffer, "");
		else
			sprintf(buffer,"%.1f KB/s",(float)partfile->GetDatarate()/1024);
		
		dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DLC_DT_TEXT);

		//set up tree vars
		cur_rec.left = cur_rec.right;
		cur_rec.right = cur_rec.right + min(7, GetColumnWidth(4));
		tree_start = cur_rec.left;
		tree_end = cur_rec.right;

		// Progress
		cur_rec.left = cur_rec.right + 1;
		cur_rec.right = tree_start + GetColumnWidth(4) - 2;
		if(cur_rec.left < cur_rec.right) {
			cur_rec.bottom --;
			cur_rec.top ++;
			// added
			int  iWidth = cur_rec.right - cur_rec.left; 
			int iHeight = cur_rec.bottom - cur_rec.top;
			if (content->status == (HBITMAP)NULL)
				VERIFY(content->status.CreateBitmap(1, 1, 1, 8, NULL)); 
			CDC cdcStatus; 
			cdcStatus.CreateCompatibleDC(&dc); 
			int cx = content->status.GetBitmapDimension().cx; 
			DWORD dwTicks = GetTickCount(); 
			if(content->dwUpdated + DLC_BARUPDATE < dwTicks || cx !=  iWidth || !content->dwUpdated) { 
				content->status.DeleteObject(); 
				content->status.CreateCompatibleBitmap(&dc,  iWidth, iHeight); 
				content->status.SetBitmapDimension(iWidth,  iHeight); 
				cdcStatus.SelectObject(content->status); 

				RECT rec_status; 
				rec_status.left = 0; 
				rec_status.top = 0; 
				rec_status.bottom = iHeight; 
				rec_status.right = iWidth; 
				partfile->DrawStatusBar(&cdcStatus,  &rec_status, theApp.glob_prefs->UseFlatBar()); 

				content->dwUpdated = dwTicks + (rand() % 128); 
			} else 
				cdcStatus.SelectObject(content->status); 

			dc->BitBlt(cur_rec.left, cur_rec.top, iWidth, iHeight,  &cdcStatus, 0, 0, SRCCOPY); 
			//added end
			cur_rec.bottom ++;
			cur_rec.top --;
		}
		cur_rec.right = tree_start + GetColumnWidth(4);

		//sources
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(5);
		
		if(partfile->GetNoNeededPartSourcesCount()>0) sprintf(buffer2,"%i/",partfile->GetSourceCount() -partfile->GetNoNeededPartSourcesCount()); else sprintf(buffer2,"");
		sprintf(buffer,"%s%i (%i)",buffer2,
			partfile->GetSourceCount(),
			partfile->GetTransferingSrcCount());
		
		dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DLC_DT_TEXT);
		//prio
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(6);
		switch(partfile->GetPriority()){
		case 0:
			dc->DrawText(GetResString(IDS_PRIOLOW) ,GetResString(IDS_PRIOLOW).GetLength(),&cur_rec, DLC_DT_TEXT);
			break;
		case 1:
			dc->DrawText(GetResString(IDS_PRIONORMAL),GetResString(IDS_PRIONORMAL).GetLength(),&cur_rec, DLC_DT_TEXT);
			break;
		case 2:
			dc->DrawText(GetResString(IDS_PRIOHIGH),GetResString(IDS_PRIOHIGH).GetLength(),&cur_rec, DLC_DT_TEXT);
			break;
		default:
			break;
		}
		//<<--9/21/02
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(7);
		sprintf(buffer,"%s", partfile->getPartfileStatus());
		dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DLC_DT_TEXT);
		// Remaining Time & Size
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(8);
		char bufferSize[50];
		char bufferTime[50];

		//size 
		uint32 remains;
		remains=partfile->GetFileSize()-partfile->GetCompletedSize();		//<<-- 09/27/2002, CML

		if( remains < 0 ) remains = 0;
		CastItoXBytes(remains,bufferSize);

		// time 
		sint32 restTime=partfile->getTimeRemaining();
		CastSecondsToHM(restTime,bufferTime);
		sprintf(buffer,"%s (%s)",bufferTime,bufferSize);
		if (partfile->GetStatus()==PS_COMPLETING || partfile->GetStatus()==PS_COMPLETE )
			sprintf(buffer,"");

		dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DLC_DT_TEXT);
	}
	else if (content->type == 3 || content->type == 2){
		CUpDownClient* client = (CUpDownClient*)content->value;
		//icon, name, status
		cur_rec.right = cur_rec.left + GetColumnWidth(0) + GetColumnWidth(1);
		cur_rec.left += 7;
		CString status;
		POINT point= {cur_rec.left,cur_rec.top+1};
		if (content->type == 2){
			switch (client->GetDownloadState()){
				case DS_CONNECTING:
					m_ImageList.Draw(dc, 2, point, ILD_NORMAL);
					status = GetResString(IDS_CONNECTING);
					break;
				case DS_CONNECTED:
					m_ImageList.Draw(dc, 2, point, ILD_NORMAL);
					status = GetResString(IDS_ASKING);
					break;
				case DS_WAITCALLBACK:
					m_ImageList.Draw(dc, 2, point, ILD_NORMAL);
					status = GetResString(IDS_CONNVIASERVER);
					break;
				case DS_ONQUEUE:
					m_ImageList.Draw(dc, 1, point, ILD_NORMAL);
					status = GetResString(IDS_ONQUEUE);
					break;
				case DS_DOWNLOADING:
					m_ImageList.Draw(dc, 0, point, ILD_NORMAL);
					status = GetResString(IDS_TRANSFERRING);
					break;
				case DS_REQHASHSET:
					m_ImageList.Draw(dc, 0, point, ILD_NORMAL);
					status = GetResString(IDS_RECHASHSET);
					break;
				case DS_NONEEDEDPARTS:
					m_ImageList.Draw(dc, 3, point, ILD_NORMAL);
					status = GetResString(IDS_NONEEDEDPARTS);
					break;
				case DS_LOWTOLOWIP:
					m_ImageList.Draw(dc, 3, point, ILD_NORMAL);
					status = GetResString(IDS_NOCONNECTLOW2LOW);
					break;
				default:
					m_ImageList.Draw(dc, 4, point, ILD_NORMAL);
					status = GetResString(IDS_UNKNOWN);
			}
		}
		else{
			
			m_ImageList.Draw(dc, 3, point, ILD_NORMAL);
			status = GetResString(IDS_ASKED4ANOTHERFILE);
		}
		cur_rec.left += 20;

		if (client->ExtProtocolAvailable()){
			POINT point2= {cur_rec.left,cur_rec.top+1};
			m_ImageList.Draw(dc, 5, point2, ILD_NORMAL);
			cur_rec.left += 20;
		}

		char* buffer1;
		if (!client->GetUserName()){
			buffer1 = new char[50];
			sprintf(buffer1,"?  (%s)",status);
		}
		else{
			buffer1 = new char[strlen(client->GetUserName())+50];
			sprintf(buffer1,"%s  (%s)",client->GetUserName(),status);
		}
		dc->DrawText(buffer1,(int)strlen(buffer1),&cur_rec, DLC_DT_TEXT);
		delete[] buffer1;
		if (content->type == 3 || content->type == 2)
			cur_rec.left -= 7;

		char buffer[100];		
		// transfered
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(2);
		if (content->type == 2 && client->GetTransferedDown()){
			CastItoXBytes(client->GetTransferedDown(),buffer);
			dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DLC_DT_TEXT);	
		}
		// speed
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(3);
		if (content->type == 2 && client->GetDownloadDatarate()){
			if (client->GetDownloadDatarate()==0) sprintf(buffer,""); else
				sprintf(buffer,"%.1f KB/s",(float)client->GetDownloadDatarate()/1024);
			dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DLC_DT_TEXT);
		}

		//set up tree vars
		cur_rec.left = cur_rec.right;
		cur_rec.right = cur_rec.right + min(7, GetColumnWidth(4));
		tree_start = cur_rec.left;
		tree_end = cur_rec.right;

		// file info
		cur_rec.left = cur_rec.right + 1;
		cur_rec.right = tree_start + GetColumnWidth(4) - 2;
		if(cur_rec.left < cur_rec.right) { 
			cur_rec.bottom--; 
			cur_rec.top++; 

			int iWidth = cur_rec.right - cur_rec.left; 
			int iHeight = cur_rec.bottom - cur_rec.top; 
			if (content->status == (HBITMAP)NULL)
				VERIFY(content->status.CreateBitmap(1, 1, 1, 8, NULL)); 
			CDC cdcStatus; 
			cdcStatus.CreateCompatibleDC(&dc); 
			int cx = content->status.GetBitmapDimension().cx; 
			DWORD dwTicks = GetTickCount(); 
			if(content->dwUpdated + DLC_BARUPDATE < dwTicks || cx !=  iWidth  || !content->dwUpdated) { 
				content->status.DeleteObject(); 
				content->status.CreateCompatibleBitmap(&dc,  iWidth, iHeight); 
				content->status.SetBitmapDimension(iWidth,  iHeight); 
				cdcStatus.SelectObject(content->status); 

				RECT rec_status; 
				rec_status.left = 0; 
				rec_status.top = 0; 
				rec_status.bottom = iHeight; 
				rec_status.right = iWidth; 
				client->DrawStatusBar(&cdcStatus,  &rec_status,(content->type == 3), theApp.glob_prefs->UseFlatBar()); 

				content->dwUpdated = dwTicks + (rand() % 128); 
			} else 
				cdcStatus.SelectObject(content->status); 

			dc->BitBlt(cur_rec.left, cur_rec.top, iWidth, iHeight,  &cdcStatus, 0, 0, SRCCOPY); 

			cur_rec.bottom++; 
			cur_rec.top--; 
		} 


		//sources
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(5);
		//prio
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(6);
		if (client->GetRemoteQueueRank()){
			sprintf(buffer,"QR: %u",client->GetRemoteQueueRank());
			dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DLC_DT_TEXT);
		}
	}

	//draw rectangle around selected item(s)
	if ((lpDrawItemStruct->itemAction | ODA_SELECT) &&
		(lpDrawItemStruct->itemState & ODS_SELECTED) &&
		(content->type == 1)) {
			RECT outline_rec;
			memcpy(&outline_rec,&lpDrawItemStruct->rcItem,sizeof(RECT));

		outline_rec.top--;
		outline_rec.bottom++;
		dc->FrameRect(&outline_rec, &CBrush(GetBkColor()));
		outline_rec.top++;
		outline_rec.bottom--;
		outline_rec.left++;
		outline_rec.right--;

		if(notFirst && (GetItemState(lpDrawItemStruct->itemID - 1, LVIS_SELECTED))) {

			CtrlItem_Struct* prev = (CtrlItem_Struct*)this->GetItemData(lpDrawItemStruct->itemID - 1);
			if(prev->type == 1)
				outline_rec.top--;
		} 

		if(notLast && (GetItemState(lpDrawItemStruct->itemID + 1, LVIS_SELECTED))) {

			CtrlItem_Struct* next = (CtrlItem_Struct*)this->GetItemData(lpDrawItemStruct->itemID + 1);
			if(next->type == 1)
				outline_rec.bottom++;
		} 

		if(bCtrlFocused)
			dc->FrameRect(&outline_rec, &CBrush(m_crFocusLine));
		else
			dc->FrameRect(&outline_rec, &CBrush(m_crNoFocusLine));
	}

	//draw focus rectangle around non-highlightable items when they have the focus
	else if (((lpDrawItemStruct->itemState & ODS_FOCUS) == ODS_FOCUS) &&
	    (GetFocus() == this) && (content->type != 1)) {

		RECT focus_rec;
		focus_rec.top    = lpDrawItemStruct->rcItem.top;
		focus_rec.bottom = lpDrawItemStruct->rcItem.bottom;
		focus_rec.left   = lpDrawItemStruct->rcItem.left + 1;
		focus_rec.right  = lpDrawItemStruct->rcItem.right - 1;
		//dc->DrawFocusRect(&focus_rec);
		dc->FrameRect(&focus_rec, &CBrush(m_crNoFocusLine));
	}

	//draw tree last so it draws over selected and focus (looks better)
	if(tree_start < tree_end) {
		//set new bounds
		RECT tree_rect;
		tree_rect.top    = lpDrawItemStruct->rcItem.top;
		tree_rect.bottom = lpDrawItemStruct->rcItem.bottom;
		tree_rect.left   = tree_start;
		tree_rect.right  = tree_end;
		dc->SetBoundsRect(&tree_rect, DCB_DISABLE);

		//gather some information
		BOOL hasNext = notLast &&
			((CtrlItem_Struct*)this->GetItemData(lpDrawItemStruct->itemID + 1))->type != 1;
		BOOL isOpenRoot = hasNext && content->type == 1;
		BOOL isChild = content->type != 1;
		BOOL isExpandable = !isChild && ((CPartFile*)content->value)->GetSourceCount() > 0;
		//might as well calculate these now
		int treeCenter = tree_start + 3;
		int middle = (cur_rec.top + cur_rec.bottom + 1) / 2;

		//set up a new pen for drawing the tree
		CPen pn, *oldpn;
		pn.CreatePen(PS_SOLID, 1, dc->GetTextColor());
		oldpn = dc->SelectObject(&pn);

		if(isChild) {
			//draw the line to the status bar
			dc->MoveTo(tree_end, middle);
			dc->LineTo(tree_start + 3, middle);

			//draw the line to the child node
			if(hasNext) {
				dc->MoveTo(treeCenter, middle);
				dc->LineTo(treeCenter, cur_rec.bottom + 1);
			}
		} else if(isOpenRoot) {
			//draw circle
			RECT circle_rec;
			COLORREF crBk = dc->GetBkColor();
			circle_rec.top    = middle - 2;
			circle_rec.bottom = middle + 3;
			circle_rec.left   = treeCenter - 2;
			circle_rec.right  = treeCenter + 3;
			dc->FrameRect(&circle_rec, &CBrush(dc->GetTextColor()));
			dc->SetPixelV(circle_rec.left,      circle_rec.top,    crBk);
			dc->SetPixelV(circle_rec.right - 1, circle_rec.top,    crBk);
			dc->SetPixelV(circle_rec.left,      circle_rec.bottom - 1, crBk);
			dc->SetPixelV(circle_rec.right - 1, circle_rec.bottom - 1, crBk);
			//draw the line to the child node
			if(hasNext) {
				dc->MoveTo(treeCenter, middle + 3);
				dc->LineTo(treeCenter, cur_rec.bottom + 1);
			}
		} /*else if(isExpandable) {
			//draw a + sign
			dc->MoveTo(treeCenter, middle - 2);
			dc->LineTo(treeCenter, middle + 3);
			dc->MoveTo(treeCenter - 2, middle);
			dc->LineTo(treeCenter + 3, middle);
		}*/

		//draw the line back up to parent node
		if(notFirst && isChild) {
			dc->MoveTo(treeCenter, middle);
			dc->LineTo(treeCenter, cur_rec.top - 1);
		}

		//put the old pen back
		dc->SelectObject(oldpn);
		pn.DeleteObject();
	}

}


BEGIN_MESSAGE_MAP(CDownloadListCtrl, CMuleListCtrl)
	ON_NOTIFY_REFLECT(LVN_ITEMACTIVATE, OnLvnItemActivate)
	ON_NOTIFY_REFLECT(LVN_ITEMCHANGED, OnListModified)
	ON_NOTIFY_REFLECT(LVN_INSERTITEM, OnListModified)
	ON_NOTIFY_REFLECT(LVN_DELETEITEM, OnListModified)
	ON_NOTIFY_REFLECT (NM_RCLICK, OnNMRclick)
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick)
END_MESSAGE_MAP()



// CDownloadListCtrl message handlers

void CDownloadListCtrl::OnLvnItemActivate(NMHDR *pNMHDR, LRESULT *pResult){
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	CtrlItem_Struct* content = (CtrlItem_Struct*)this->GetItemData(pNMIA->iItem);

	if (content->type == 1){
		SetRedraw(false);

		CPartFile* partfile = (CPartFile*)content->value;
		
		if ( (!partfile->srcarevisible) && partfile->GetSourceCount()>0 ){
			for (POSITION pos = listcontent.GetHeadPosition();pos != 0;listcontent.GetNext(pos)){
				CtrlItem_Struct* cur_item = (CtrlItem_Struct*)listcontent.GetAt(pos);
				if (cur_item->owner == partfile){
					InsertItem(LVIF_PARAM,pNMIA->iItem+1,0,0,0,0,(LPARAM)cur_item);
				}
			}
			partfile->srcarevisible = true;
		}
		else{
			while (GetItemCount() > pNMIA->iItem+1 && ((CtrlItem_Struct*)GetItemData(pNMIA->iItem+1))->type != 1){
				CtrlItem_Struct* cur_item = (CtrlItem_Struct*)GetItemData(pNMIA->iItem+1);
				cur_item->dwUpdated = 0;
				cur_item->status.DeleteObject();
				DeleteItem(pNMIA->iItem+1);
			}
			partfile->srcarevisible = false;
		}
		SetRedraw(true);
	}
	*pResult = 0;
}

void CDownloadListCtrl::OnNMRclick(NMHDR *pNMHDR, LRESULT *pResult){	
	POINT point;
	::GetCursorPos(&point);
	if (GetSelectionMark() != (-1)){
		CtrlItem_Struct* content = (CtrlItem_Struct*)this->GetItemData(GetSelectionMark());
		if (content->type == 1){
			CPartFile* file = (CPartFile*)content->value;

			m_FileMenu.EnableMenuItem(MP_PAUSE,((file->GetStatus() != PS_PAUSED && file->GetStatus() != PS_ERROR) ? MF_ENABLED:MF_GRAYED));
			m_FileMenu.EnableMenuItem(MP_STOP,((file->GetStatus() != PS_PAUSED && file->GetStatus() != PS_ERROR) ? MF_ENABLED:MF_GRAYED));
			m_FileMenu.EnableMenuItem(MP_RESUME,((file->GetStatus() == PS_PAUSED) ? MF_ENABLED:MF_GRAYED));
	        m_FileMenu.EnableMenuItem(MP_OPEN,((file->GetStatus() == PS_COMPLETE) ? MF_ENABLED:MF_GRAYED)); //<<--9/21/02
			m_FileMenu.EnableMenuItem(MP_PREVIEW,((file->PreviewAvailable()) ? MF_ENABLED:MF_GRAYED));

			m_FileMenu.EnableMenuItem(MP_CANCEL,MF_ENABLED);

			m_PrioMenu.CheckMenuItem(MP_PRIOHIGH,(file->GetPriority() == PR_HIGH)? MF_CHECKED:MF_UNCHECKED);
			m_PrioMenu.CheckMenuItem(MP_PRIONORMAL,(file->GetPriority() == PR_NORMAL)? MF_CHECKED:MF_UNCHECKED);
			m_PrioMenu.CheckMenuItem(MP_PRIOLOW,(file->GetPriority() == PR_LOW)? MF_CHECKED:MF_UNCHECKED);

			m_FileMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
		}else {
		
			m_ClientMenu.CreatePopupMenu();
			m_ClientMenu.AddMenuTitle(GetResString(IDS_CLIENTS));
			m_ClientMenu.AppendMenu(MF_STRING,MP_DETAIL, GetResString(IDS_SHOWDETAILS));
			m_ClientMenu.AppendMenu(MF_STRING,MP_MESSAGE, GetResString(IDS_SEND_MSG));
			m_ClientMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
			m_ClientMenu.DestroyMenu();

		}
	}
	else{
		m_FileMenu.EnableMenuItem(MP_CANCEL,MF_GRAYED);
		m_FileMenu.EnableMenuItem(MP_PAUSE,MF_GRAYED);
		m_FileMenu.EnableMenuItem(MP_STOP,MF_GRAYED);
		m_FileMenu.EnableMenuItem(MP_RESUME,MF_GRAYED);
		m_FileMenu.EnableMenuItem(MP_PREVIEW,MF_GRAYED);
		m_FileMenu.EnableMenuItem(MP_OPEN,MF_GRAYED); //<<--9/21/02
		m_FileMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
	}
	*pResult = 0;
}

BOOL CDownloadListCtrl::OnCommand(WPARAM wParam,LPARAM lParam ){
	if (GetSelectionMark() != (-1)){
		CtrlItem_Struct* content = (CtrlItem_Struct*)this->GetItemData(GetSelectionMark());
		
		///////////////////////////////////////////////////////////// 
		//for multiple selections 
		UINT selectedCount = this->GetSelectedCount(); 
		CTypedPtrList<CPtrList, CPartFile*> selectedList; 
		int index = -1; 
		POSITION pos = this->GetFirstSelectedItemPosition(); 
		while(pos != NULL) 
		{ 
			index = this->GetNextSelectedItem(pos); 
			if(index > -1) 
			{
				if (((CtrlItem_Struct*)this->GetItemData(index))->type == 1) 
					selectedList.AddTail((CPartFile*)((CtrlItem_Struct*)this->GetItemData(index))->value); 
			} 
		} 

		if (content->type == 1){
			CPartFile* file = (CPartFile*)content->value;

			switch (wParam)
			{
				case MP_CANCEL:
				{
					//for multiple selections 
					if(selectedCount > 1)
					{ 
						CString fileList; 
						for (pos = selectedList.GetHeadPosition() ; pos != 0 ; selectedList.GetNext(pos))
						{
							fileList += "\n" ; 
							fileList += selectedList.GetAt(pos)->GetFileName(); 
						} 
						if (MessageBox((GetResString(IDS_Q_CANCELDL) + fileList),GetResString(IDS_CANCEL),MB_ICONQUESTION|MB_YESNO) == IDYES)
						{ 
							while(!selectedList.IsEmpty())
							{
								switch(selectedList.GetHead()->GetStatus()) { 
									case PS_WAITINGFORHASH: 
									case PS_HASHING: 
									case PS_COMPLETING: 
									case PS_COMPLETE: 
										selectedList.RemoveHead(); 
										break; 
									default: 
									selectedList.GetHead()->DeleteFile(); 
									selectedList.RemoveHead(); 
								}
							}  
						}
						break; 
					}
					// single selection
					switch(file->GetStatus())
					{
						case PS_WAITINGFORHASH:
						case PS_HASHING:
						case PS_COMPLETING:
						case PS_COMPLETE:
							break;
						default:
						if (MessageBox(GetResString(IDS_Q_CANCELDL2),GetResString(IDS_CANCEL),MB_ICONQUESTION|MB_YESNO) == IDYES)
			                file->DeleteFile();
						break;
					}
					break;
				}
				case MP_PRIOHIGH:
					if(selectedCount > 1)
					{
						while(!selectedList.IsEmpty()) { 
							selectedList.GetHead()->SetPriority(PR_HIGH); 
							selectedList.RemoveHead(); 
						} 
						break; 
					} 
					file->SetPriority(PR_HIGH);
					break;
				case MP_PRIOLOW:
					if(selectedCount > 1)
					{
						while(!selectedList.IsEmpty()) { 
							selectedList.GetHead()->SetPriority(PR_LOW); 
							selectedList.RemoveHead(); 
						} 
						break; 
					} 
					file->SetPriority(PR_LOW);
					break;
				case MP_PRIONORMAL:
					if(selectedCount > 1)
					{
						while(!selectedList.IsEmpty()) { 
							selectedList.GetHead()->SetPriority(PR_NORMAL); 
							selectedList.RemoveHead(); 
						} 
						break; 
					} 
					file->SetPriority(PR_NORMAL);
					break;
				case MP_PAUSE:
					if(selectedCount > 1)
					{
						while(!selectedList.IsEmpty()) { 
							selectedList.GetHead()->PauseFile(); 
							selectedList.RemoveHead(); 
						} 
						break; 
					} 
					file->PauseFile();
					break;
				case MP_RESUME:
					if(selectedCount > 1)
					{
						while(!selectedList.IsEmpty()) { 
							selectedList.GetHead()->ResumeFile(); 
							selectedList.RemoveHead(); 
						} 
						break; 
					} 
					file->ResumeFile();
					break;
				case MP_STOP:
					if(selectedCount > 1)
					{
						while(!selectedList.IsEmpty()) { 
							selectedList.GetHead()->StopFile(); 
							selectedList.RemoveHead(); 
						} 
						break; 
					} 
					file->StopFile();
					break;
				case MP_CLEARCOMPLETED:
					ClearCompleted();
					break;
				case MP_METINFO:
					{
						CFileDetailDialog dialog(file);
						dialog.DoModal();
						break;
					}
				case MP_GETED2KLINK:
					if(selectedCount > 1)
					{
						CString str;
						while(!selectedList.IsEmpty()) { 
							str += theApp.CreateED2kLink(selectedList.GetHead()) + "\n"; 
							selectedList.RemoveHead(); 
						}
						theApp.CopyTextToClipboard(str);
						AfxMessageBox(GetResString(IDS_COPIED2CB) + str);
						break; 
					} 
					theApp.CopyTextToClipboard(theApp.CreateED2kLink(file));
					break;
				case MP_GETHTMLED2KLINK:
					if(selectedCount > 1)
					{
						CString str;
						while(!selectedList.IsEmpty()) { 
							str += theApp.CreateHTMLED2kLink(selectedList.GetHead()) + "\n"; 
							selectedList.RemoveHead(); 
						}
						theApp.CopyTextToClipboard(str);
						AfxMessageBox(GetResString(IDS_COPIED2CB) + str);
						break; 
					} 
					theApp.CopyTextToClipboard(theApp.CreateHTMLED2kLink(file));
					break;
				case MP_OPEN:{
					if(selectedCount > 1)
						break;
					char* buffer = new char[250];
					sprintf(buffer,"%s\\%s",theApp.glob_prefs->GetIncomingDir(),file->GetFileName());
					ShellOpenFile(buffer);
					delete buffer;
					break; 
				}
				case MP_PREVIEW:{
					if(selectedCount > 1)
						break;
					file->PreviewFile();
					break;
				}
			}
		}
		else{
			CUpDownClient* client = (CUpDownClient*)content->value;
			switch (wParam){
				case MP_MESSAGE:
					theApp.emuledlg->chatwnd.StartSession(client);
					break;
				case MP_DETAIL:
					CClientDetailDialog dialog(client);
					dialog.DoModal();
					break;
			}
		}
		// cleanup multiselection
		selectedList.RemoveAll(); 

	}
	else /*nothing selected*/
	{
		switch (wParam){
			case MP_CLEARCOMPLETED:
				ClearCompleted();
				break;
		}

	}

	return true;
}

void CDownloadListCtrl::OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult){
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	HDITEM headerItem;
	headerItem.mask = HDI_FORMAT | HDI_BITMAP;
	CHeaderCtrl* pHeaderCtrl = GetHeaderCtrl();
	pHeaderCtrl->GetItem(pNMListView->iSubItem, &headerItem);
	if (headerItem.hbm != 0) {
		DeleteObject(headerItem.hbm);
		headerItem.hbm = 0;
	}
	headerItem.fmt |= HDF_BITMAP | HDF_BITMAP_ON_RIGHT;
	m_SortAscending = (m_CurrentSortItem != pNMListView->iSubItem) ? true : !m_SortAscending;
	headerItem.hbm = (HBITMAP)LoadImage(AfxGetInstanceHandle(),
		MAKEINTRESOURCE(m_SortAscending ? IDB_UP : IDB_DOWN),
		IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS);
	pHeaderCtrl->SetItem(pNMListView->iSubItem, &headerItem);
	if (m_CurrentSortItem != pNMListView->iSubItem) {
		pHeaderCtrl->GetItem(m_CurrentSortItem, &headerItem);
		headerItem.fmt &= ~(HDF_BITMAP | HDF_BITMAP_ON_RIGHT);
		if (headerItem.hbm != 0) {
			DeleteObject(headerItem.hbm);
			headerItem.hbm = 0;
		}
		pHeaderCtrl->SetItem(m_CurrentSortItem, &headerItem);
		m_CurrentSortItem = pNMListView->iSubItem;
	}

	for (int i = 0, max = GetItemCount(); i < max; i++) {
		CtrlItem_Struct* item = (CtrlItem_Struct*)this->GetItemData(i);
		item->location = i;
	}

	SortItems(&SortProc,pNMListView->iSubItem + (m_SortAscending ? 0:10));
}

int CDownloadListCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort){
        CtrlItem_Struct* item1 = (CtrlItem_Struct*)lParam1;
        CtrlItem_Struct* item2 = (CtrlItem_Struct*)lParam2;

        int sortMod = 1;
        if(lParamSort >= 10) {
                sortMod = -1;
                lParamSort -= 10;
        }

        int comp;

        if(item1->type == 1 && item2->type != 1) {
                if(item1->value == item2->parent->value)
                        return -1;

                comp = Compare((CPartFile*)item1->value, (CPartFile*)(item2->parent->value), lParamSort);

        } else if(item2->type == 1 && item1->type != 1) {
                if(item1->parent->value == item2->value)
                        return -1;

                comp = Compare((CPartFile*)(item1->parent->value), (CPartFile*)item2->value, lParamSort);

        } else if (item1->type == 1) {
                CPartFile* file1 = (CPartFile*)item1->value;
                CPartFile* file2 = (CPartFile*)item2->value;

                comp = Compare(file1, file2, lParamSort);

        } else {
                CUpDownClient* client1 = (CUpDownClient*)item1->value;
                CUpDownClient* client2 = (CUpDownClient*)item2->value;
                comp = Compare((CPartFile*)(item1->parent->value), (CPartFile*)(item2->parent->value), lParamSort);
                if(comp != 0)
                        return sortMod * comp;
                if (item1->type != item2->type)
                        return item1->type - item2->type;
                
                comp = Compare(client1, client2, lParamSort);
        }

        if(comp == 0)
                return item1->location - item2->location;
        return sortMod * comp;
}


void CDownloadListCtrl::ClearCompleted(){
   POSITION pos1, pos2;
   for( pos1 = listcontent.GetHeadPosition(); ( pos2 = pos1 ) != NULL; ){
	   listcontent.GetNext(pos1);
	   CtrlItem_Struct* delitem = listcontent.GetAt(pos2);
	   if (delitem->type == 1){
		   CPartFile* file = (CPartFile*)delitem->value;
		   if (!file->IsPartFile())
			   RemoveFile(file);
	   }
   }
}

void CDownloadListCtrl::SetStyle() {
	if (theApp.glob_prefs->IsDoubleClickEnabled())
		SetExtendedStyle(LVS_EX_FULLROWSELECT);
	else
		SetExtendedStyle(LVS_EX_ONECLICKACTIVATE | LVS_EX_FULLROWSELECT);
}

void CDownloadListCtrl::OnListModified(NMHDR *pNMHDR, LRESULT *pResult) {
	NM_LISTVIEW *pNMListView = (NM_LISTVIEW*)pNMHDR;

	//this works because true is equal to 1 and false equal to 0
	BOOL notLast = pNMListView->iItem + 1 != GetItemCount();
	BOOL notFirst = pNMListView->iItem != 0;
	RedrawItems(pNMListView->iItem - notFirst, pNMListView->iItem + notLast);
}

int CDownloadListCtrl::Compare(CPartFile* file1, CPartFile* file2, LPARAM lParamSort) {
        switch(lParamSort){
        case 0: //filename asc
                return strcmpi(file1->GetFileName(),file2->GetFileName());
        case 1: //size asc
                return file1->GetFileSize() - file2->GetFileSize();
        case 2: //transfered asc
                return file1->GetTransfered() - file2->GetTransfered();
        case 3: //speed asc
                return file1->GetDatarate() - file2->GetDatarate();
        case 4: //progress asc
                {
                        float comp = file1->GetPercentCompleted() - file2->GetPercentCompleted();
                        if(comp > 0)
                                return 1;
                        else if(comp < 0)
                                return -1;
                        else
                                return 0;
                }
        case 5: //sources asc
                return file1->GetSourceCount() - file2->GetSourceCount();
        case 6: //priority asc
                return file1->GetPriority() - file2->GetPriority();
        case 7: //Status asc 
                return file1->getPartfileStatus().Compare(file2->getPartfileStatus()); 
        case 8: //Remaining Time asc 
                return file1->getTimeRemaining()-file2->getTimeRemaining() ;
        default:
                return 0;
        }
}

int CDownloadListCtrl::Compare(CUpDownClient *client1, CUpDownClient *client2, LPARAM lParamSort) {
        switch(lParamSort){
        case 0: //name asc
                if (!client1->GetUserName())
                        return 1;
                else if(!client2->GetUserName())
                        return -1;
                return strcmp(client1->GetUserName(),client2->GetUserName());
        case 1: //size but we use status asc
                return client1->GetDownloadState() - client2->GetDownloadState();
        case 2: //transfered asc
                return client1->GetTransferedDown() - client2->GetTransferedDown();
        case 3: //speed asc
                return client1->GetDownloadDatarate() - client2->GetDownloadDatarate();
        case 4: //progress asc
                return client2->GetAvailablePartCount() - client1->GetAvailablePartCount();
        default:
                return 0;
        }
}

void CDownloadListCtrl::CreateMenues() {
	if (m_PrioMenu) m_PrioMenu.DestroyMenu();
	if (m_FileMenu) m_FileMenu.DestroyMenu();

	m_PrioMenu.CreateMenu();
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOLOW,GetResString(IDS_PRIOLOW));
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIONORMAL,GetResString(IDS_PRIONORMAL));
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOHIGH, GetResString(IDS_PRIOHIGH));

	m_FileMenu.CreatePopupMenu();
	m_FileMenu.AddMenuTitle(GetResString(IDS_DOWNLOADMENUTITLE));
	m_FileMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_PrioMenu.m_hMenu, GetResString(IDS_PRIORITY) );

	m_FileMenu.AppendMenu(MF_STRING,MP_CANCEL,GetResString(IDS_MAIN_BTN_CANCEL) );
	m_FileMenu.AppendMenu(MF_STRING,MP_STOP, GetResString(IDS_DL_STOP));
	m_FileMenu.AppendMenu(MF_STRING,MP_PAUSE, GetResString(IDS_DL_PAUSE));
	m_FileMenu.AppendMenu(MF_STRING,MP_RESUME, GetResString(IDS_DL_RESUME));
	m_FileMenu.AppendMenu(MF_SEPARATOR);
	m_FileMenu.AppendMenu(MF_STRING,MP_OPEN, GetResString(IDS_DL_OPEN) );//<--9/21/02
	m_FileMenu.AppendMenu(MF_STRING,MP_PREVIEW, GetResString(IDS_DL_PREVIEW) );
	m_FileMenu.AppendMenu(MF_STRING,MP_METINFO, GetResString(IDS_DL_INFO) );//<--9/21/02
	m_FileMenu.AppendMenu(MF_SEPARATOR);
	m_FileMenu.AppendMenu(MF_STRING,MP_CLEARCOMPLETED, GetResString(IDS_DL_CLEAR));
	m_FileMenu.AppendMenu(MF_STRING,MP_GETED2KLINK, GetResString(IDS_DL_LINK1) );
	m_FileMenu.AppendMenu(MF_STRING,MP_GETHTMLED2KLINK, GetResString(IDS_DL_LINK2));
	SetMenu(&m_FileMenu);
}
