#pragma once

#include "PPgGeneral.h"
#include "PPgConnection.h"
#include "PPgServer.h"
#include "PPgDirectories.h"
#include "PPgFiles.h"
#include "otherfunctions.h"

// CPreferencesDlg

class CPreferencesDlg : public CPropertySheet
{
	DECLARE_DYNAMIC(CPreferencesDlg)

public:
	CPreferencesDlg();
	virtual ~CPreferencesDlg();
	
protected:
	UINT m_nActiveWnd;
	DECLARE_MESSAGE_MAP()
public:
	CPPgGeneral		m_wndGeneral;
	CPPgConnection	m_wndConnection;
	CPPgServer		m_wndServer;
	CPPgDirectories	m_wndDirectories;
	CPPgFiles		m_wndFiles;

	CPreferences	*app_prefs;

	void SetPrefs(CPreferences* in_prefs)
	{
		app_prefs = in_prefs;
		m_wndGeneral.SetPrefs(in_prefs);
		m_wndConnection.SetPrefs(in_prefs);
		m_wndServer.SetPrefs(in_prefs);
		m_wndDirectories.SetPrefs(in_prefs);
		m_wndFiles.SetPrefs(in_prefs);
	}
	afx_msg void OnDestroy();
	virtual BOOL OnInitDialog();

	void Localize(void)
	{
		//SetWindowText(GetResString(IDS_PREFERENCES_CAPTION));
		m_wndGeneral.Localize();
		m_wndConnection.Localize();
		m_wndServer.Localize();
		m_wndDirectories.Localize();
		m_wndFiles.Localize();
	}
};


