//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// StatisticsDlg.cpp : implementation file
//
#include "stdafx.h"
#include "emule.h"
#include "StatisticsDlg.h"
#include "uploadqueue.h"

// CStatisticsDlg dialog

IMPLEMENT_DYNAMIC(CStatisticsDlg, CDialog)
CStatisticsDlg::CStatisticsDlg(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CStatisticsDlg::IDD, pParent) , m_DownloadOMeter( 3 ),m_Statistics(4),m_UploadOMeter(3)
{

}

CStatisticsDlg::~CStatisticsDlg()
{
}

void CStatisticsDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExoSliderDlg)
	DDX_Text(pDX, IDC_SLIDER_VALUE, m_SliderValue);
	DDX_Control(pDX, IDC_STATTREE, stattree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStatisticsDlg, CResizableDialog)
	//{{AFX_MSG_MAP(CStatisticsDlg)
	ON_WM_SHOWWINDOW()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CStatisticsDlg message handlers

BOOL CStatisticsDlg::OnInitDialog(){

	CResizableDialog::OnInitDialog();
	Localize();
	EnableWindow( FALSE );

	AddAnchor(IDC_STATIC_LINE,TOP_LEFT ,TOP_RIGHT);
	AddAnchor(IDC_SLIDER,TOP_LEFT ,TOP_RIGHT);
	AddAnchor(IDC_SLIDER_VALUE,TOP_LEFT ,TOP_RIGHT);
	AddAnchor(IDC_STATTREE,TOP_LEFT ,BOTTOM_RIGHT);

	// setup tree
	h_transfer= stattree.InsertItem(GetResString(IDS_FSTAT_TRANSFER));
	tran0= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_transfer);

	h_upload = stattree.InsertItem(GetResString(IDS_TW_UPLOADS), h_transfer);
	up1= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_upload);
	up2= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_upload);
	up3= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_upload);
	up4= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_upload);
	up5= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_upload);
	up6= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_upload);

	h_download = stattree.InsertItem(GetResString(IDS_TW_DOWNLOADS), h_transfer);
	down1= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_download);
	down2= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_download);
	down3= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_download);

	h_connection = stattree.InsertItem(GetResString(IDS_FSTAT_CONNECTION));
	con1= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_connection);
	con2= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_connection);
	con3= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_connection);
	con4= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_connection);
	con5= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_connection);
	con6= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_connection);
	con7= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_connection);
	con8= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_connection);
	con9= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_connection);

	h_clients = stattree.InsertItem(GetResString(IDS_CLIENTS));
	cli1= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_clients);
	cli2= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_clients);
	cli3= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_clients);

	h_servers = stattree.InsertItem(GetResString(IDS_FSTAT_SERVERS));
	srv1= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_servers);
	srv2= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_servers);
	srv3= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_servers);
	srv4= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_servers);
	srv5= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_servers);
	srv6= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_servers);
	srv7= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_servers);
	srv8= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_servers);

	h_shared = stattree.InsertItem( GetResString(IDS_SHAREDFILES) );
	shar1= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_shared);
	shar2= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_shared);
	shar3= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_shared);

	stattree.Expand(h_transfer,TVE_EXPAND);
	stattree.Expand(h_connection,TVE_EXPAND);
	stattree.Expand(h_clients,TVE_EXPAND);
	stattree.Expand(h_servers,TVE_EXPAND);
	stattree.Expand(h_shared ,TVE_EXPAND);
	stattree.Expand(h_upload,TVE_EXPAND);
	stattree.Expand(h_download,TVE_EXPAND);

	// Setup download-scope
	CRect rect;
	GetDlgItem(IDC_SCOPE_D)->GetWindowRect(rect) ;
	ScreenToClient(rect) ;
	m_DownloadOMeter.Create(WS_VISIBLE | WS_CHILD, rect, this) ; 
	m_DownloadOMeter.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_DownloadOMeter.SetGridColor(RGB(192, 192, 255)) ;
	m_DownloadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphDownloadRate()+4, 0) ;
	m_DownloadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphDownloadRate()+4, 1) ;
	m_DownloadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphDownloadRate()+4, 2) ;
	m_DownloadOMeter.SetPlotColor( RGB(0, 128, 0),0) ;
	m_DownloadOMeter.SetPlotColor( RGB(0, 210, 0),1) ;
	m_DownloadOMeter.SetPlotColor( RGB(128, 255, 128),2) ;
	m_DownloadOMeter.SetYUnits("kB / s") ;
	//m_DownloadOMeter.SetXUnits(GetResString(IDS_TIME));

	// Setup upload-scope
	GetDlgItem(IDC_SCOPE_U)->GetWindowRect(rect) ;
	ScreenToClient(rect) ;
	m_UploadOMeter.Create(WS_VISIBLE | WS_CHILD, rect, this) ; 
	m_UploadOMeter.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_UploadOMeter.SetGridColor(RGB(192, 192, 255)) ;
	m_UploadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphUploadRate()+4, 0) ;
	m_UploadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphUploadRate()+4, 1) ;
	m_UploadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphUploadRate()+4, 2) ;
	m_UploadOMeter.SetPlotColor( RGB(140, 0, 0)  ,0) ;
	m_UploadOMeter.SetPlotColor( RGB(200, 0, 0)  ,1) ;
	m_UploadOMeter.SetPlotColor( RGB(255, 128, 128),2) ;
	m_UploadOMeter.SetYUnits("kB / s") ;
	//m_UploadOMeter.SetXUnits(GetResString(IDS_TIME));

	// Setup additional graph-scope
	GetDlgItem(IDC_STATSSCOPE)->GetWindowRect(rect) ;
	ScreenToClient(rect) ;
	m_Statistics.Create(WS_VISIBLE | WS_CHILD, rect, this) ; 
	m_Statistics.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_Statistics.SetGridColor(RGB(192, 192, 255)) ;
	m_Statistics.SetRanges(0, theApp.glob_prefs->GetStatsMax()) ;
	m_Statistics.autofitYscale=true;

	m_Statistics.SetPlotColor( RGB(150, 150, 255),0) ;
	m_Statistics.SetPlotColor( RGB(192,   0, 192),1) ;
	m_Statistics.SetPlotColor( RGB(255, 192, 255),2) ;
	m_Statistics.SetPlotColor( RGB(255, 255, 128),3) ;
	m_Statistics.SetYUnits("") ;
	m_Statistics.SetXUnits(GetResString(IDS_TIME));

	SetupLegend( IDC_C0_2, 0 ,1);
	SetupLegend( IDC_C0_3, 1 ,1);
	SetupLegend( IDC_C0,   2 ,1);
	
	SetupLegend( IDC_C1_2, 0 ,2 );
	SetupLegend( IDC_C1_3, 1 ,2 );
	SetupLegend( IDC_C1,   2 ,2 );
	

	SetupLegend( IDC_S0, 0 ,3);
	SetupLegend( IDC_S1, 1 ,3);
	//SetupLegend( IDC_S2, 2 ,3);
	SetupLegend( IDC_S3, 3 ,3);

	UpdateData(FALSE);

	EnableWindow( TRUE );

	peakconnections = 0;
	totalconnectionchecks = 0;
	averageconnections = 0;
	activeconnections = 0;
	return true;
}

void CStatisticsDlg::SetupLegend( int ResIdx, int ElmtIdx, int legendNr){
	CRect Rect;

	GetDlgItem( ResIdx )->GetWindowRect( Rect );
	ScreenToClient( Rect );
	
	if (legendNr==1){
		m_Led1[ ElmtIdx ].Create( WS_VISIBLE | WS_CHILD, Rect, this );
		m_Led1[ ElmtIdx ].SetBackgroundColor( m_DownloadOMeter.GetPlotColor( ElmtIdx ) );
		m_Led1[ ElmtIdx ].SetFrameColor( RGB( 0x00, 0x00, 0x00 ) );
	} else if (legendNr==2) {
		m_Led2[ ElmtIdx ].Create( WS_VISIBLE | WS_CHILD, Rect, this );
		m_Led2[ ElmtIdx ].SetBackgroundColor( m_UploadOMeter.GetPlotColor( ElmtIdx ) );
		m_Led2[ ElmtIdx ].SetFrameColor( RGB( 0x00, 0x00, 0x00 ) );
	} else if (legendNr==3){
		m_Led3[ ElmtIdx ].Create( WS_VISIBLE | WS_CHILD, Rect, this );
		m_Led3[ ElmtIdx ].SetBackgroundColor( m_Statistics.GetPlotColor( ElmtIdx ) );
		m_Led3[ ElmtIdx ].SetFrameColor( RGB( 0x00, 0x00, 0x00 ) );
	}
}


void CStatisticsDlg::SetCurrentRate(float uploadrate, float downloadrate) {
	double m_dPlotDataUp[ 3 ];
	double m_dPlotDataDown[ 3 ];
	int myStats[6];

	// current rate
	m_dPlotDataDown[2]=downloadrate;
	m_dPlotDataUp[2]=uploadrate;

	// averages
	m_dPlotDataDown[0]=	GetAvgDownloadRate(AVG_SESSION);
	m_dPlotDataUp[0]=	GetAvgUploadRate(AVG_SESSION);

	m_dPlotDataDown[1]=	GetAvgDownloadRate(AVG_TIME);
	m_dPlotDataUp[1]=	GetAvgUploadRate(AVG_TIME);

	// show
	m_DownloadOMeter.AppendPoints(m_dPlotDataDown);
	m_UploadOMeter.AppendPoints(m_dPlotDataUp);


	// get Partialfiles summary
	activeconnections = theApp.listensocket->GetOpenSockets();

	theApp.downloadqueue->GetDownloadStats(myStats);
	m_dPlotDataMore[0]=(activeconnections/3);//myStats[0];
	m_dPlotDataMore[1]=theApp.uploadqueue->GetUploadQueueLength();
	m_dPlotDataMore[2]=0;//theApp.uploadqueue->GetWaitingUserCount();
	m_dPlotDataMore[3]=myStats[1];

	//for (int i=0;i<4;i++) if (m_dPlotDataMore[i]>theApp.glob_prefs->GetStatsMax()) {resize=true;theApp.glob_prefs->GetStatsMax()=(int)m_dPlotDataMore[i];}
	//if (resize) m_Statistics.SetRanges(0, theApp.glob_prefs->GetStatsMax()+15) ;
	 
	m_Statistics.AppendPoints(m_dPlotDataMore);
}

void CStatisticsDlg::UpdateConnectionsStatus(){
	if( peakconnections < activeconnections )
		peakconnections = activeconnections;
	if( theApp.serverconnect->IsConnected() ){
	totalconnectionchecks++;
	float percent;
	percent = (float)((float)(totalconnectionchecks-1)/(float)totalconnectionchecks);
	if( percent > .99 )
		percent = (float).99;
	averageconnections = (averageconnections*percent) + (float)((float)activeconnections*(float)(1-percent));
	}
}

void CStatisticsDlg::RecordRate() {
	
	if (theApp.stat_transferStarttime==0) return;
	// every second
	downrateHistory.push_front(theApp.stat_sessionReceivedBytes);
	uprateHistory.push_front(theApp.stat_sessionSentBytes);
	
	// limit to maxmins 
	while ((int)downrateHistory.size()>(int)( theApp.glob_prefs->GetStatsAverageMinutes()*60)) { 
		downrateHistory.pop_back();
		uprateHistory.pop_back();
	}
}

void CStatisticsDlg::ShowStatistics() {
	char buffer[50];char buffer2[50];
	CString cbuffer;
	bool resize;
	DWORD running;
	int myStats[6];

	resize=false;
	UpdateConnectionsStatus();
	theApp.downloadqueue->GetDownloadStats(myStats);

	CastItoXBytes( theApp.stat_sessionReceivedBytes ,buffer);
	CastItoXBytes( theApp.stat_sessionReceivedBytes+theApp.glob_prefs->GetTotalDownloaded() ,buffer2);
	cbuffer.Format(GetResString(IDS_STATS_DDATA),buffer,buffer2);
	stattree.SetItemText(down1, cbuffer);

	CastItoXBytes( theApp.stat_sessionSentBytes  ,buffer);
	CastItoXBytes( theApp.stat_sessionSentBytes+theApp.glob_prefs->GetTotalUploaded() ,buffer2);
	cbuffer.Format(GetResString(IDS_STATS_UDATA),buffer,buffer2);
	stattree.SetItemText(up1, cbuffer);

	if (theApp.stat_transferStarttime>0) {
		cbuffer.Format(GetResString(IDS_STATS_AVGDL),GetAvgDownloadRate(AVG_SESSION));
		stattree.SetItemText(con1, cbuffer);

		cbuffer.Format(GetResString(IDS_STATS_AVGUL),GetAvgUploadRate(AVG_SESSION));
		stattree.SetItemText(con2, cbuffer);
	}

	cbuffer.Format(GetResString(IDS_STATS_FOUNDSRC),myStats[0]);
	stattree.SetItemText(down2, cbuffer);

    cbuffer.Format(GetResString(IDS_STATS_ACTDL),myStats[1]);
	stattree.SetItemText(down3, cbuffer);
	cbuffer.Format(GetResString(IDS_STATS_ACTUL),theApp.uploadqueue->GetUploadQueueLength());
	stattree.SetItemText(up2, cbuffer);
	cbuffer.Format(GetResString(IDS_STATS_WAITINGUSERS),theApp.uploadqueue->GetWaitingUserCount());
	stattree.SetItemText(up3, cbuffer);
	cbuffer.Format(GetResString(IDS_STATS_SUCCUPCOUNT),theApp.uploadqueue->GetSuccessfullUpCount());
	stattree.SetItemText(up4, cbuffer);
	cbuffer.Format(GetResString(IDS_STATS_FAILUPCOUNT),theApp.uploadqueue->GetFailedUpCount());
	stattree.SetItemText(up5, cbuffer);
	running=theApp.uploadqueue->GetAverageUpTime();
	CastSecondsToHM(running,buffer);
	cbuffer.Format(GetResString(IDS_STATS_AVEUPTIME),buffer);
	stattree.SetItemText(up6, cbuffer);

	if (theApp.stat_reconnects>0) cbuffer.Format(GetResString(IDS_STATS_RECONNECTS),theApp.stat_reconnects-1);
		else cbuffer.Format(GetResString(IDS_STATS_RECONNECTS),0);
	stattree.SetItemText(con3, cbuffer);

	if (theApp.stat_transferStarttime==0) cbuffer.Format(GetResString(IDS_STATS_WAITTRANSF)); else {
		running=(GetTickCount()-theApp.stat_transferStarttime)/1000;
		CastSecondsToHM(running,buffer);
		cbuffer.Format(GetResString(IDS_TRANSFERTIME),buffer);
	}
	stattree.SetItemText(con4, cbuffer);

	if (theApp.stat_serverConnectTime==0) cbuffer.Format(GetResString(IDS_STATS_WAITCONN)); else {
		running=(GetTickCount()-theApp.stat_serverConnectTime)/1000;
		CastSecondsToHM(running,buffer);
		cbuffer.Format(GetResString(IDS_STATS_CONNECTEDSINCE),buffer);
	}
	stattree.SetItemText(con5, cbuffer);

	if (theApp.stat_sessionReceivedBytes>0 && theApp.stat_sessionSentBytes>0 )
		if (theApp.stat_sessionReceivedBytes<theApp.stat_sessionSentBytes) {
			cbuffer.Format(GetResString(IDS_STATS_RATIO)+" %.2f : 1",(float)theApp.stat_sessionSentBytes/theApp.stat_sessionReceivedBytes);
			stattree.SetItemText(tran0, cbuffer);
		} else {
			cbuffer.Format(GetResString(IDS_STATS_RATIO)+" 1 : %.2f",(float)theApp.stat_sessionReceivedBytes/theApp.stat_sessionSentBytes);
			stattree.SetItemText(tran0, cbuffer);
		}

	// shared files stats
	cbuffer.Format(GetResString(IDS_SHAREDFILESCOUNT),theApp.sharedfiles->GetCount());stattree.SetItemText(shar1, cbuffer);

	uint64 allsize=theApp.sharedfiles->GetDatasize();
	CastItoXBytes(allsize,buffer);

	cbuffer.Format(GetResString(IDS_SF_SIZE),buffer );stattree.SetItemText(shar2, cbuffer);
	
	if(theApp.sharedfiles->GetCount() != 0)
		CastItoXBytes((uint64)allsize/theApp.sharedfiles->GetCount(),buffer);
	else {
		buffer[0] = '-';
		buffer[1] = 0;
	}
	cbuffer.Format(GetResString(IDS_SF_AVERAGESIZE),buffer);stattree.SetItemText(shar3, cbuffer);
	
	// get clientversion-counts
	theApp.clientlist->GetStatistics(myStats);
	cbuffer.Format("eMule: %i",myStats[2]);stattree.SetItemText(cli1, cbuffer);
	cbuffer.Format("eDonkey: %i",myStats[1]);stattree.SetItemText(cli2, cbuffer);
	//cbuffer.Format("mlDonkey: %i",myStats[3]);stattree.SetItemText(shar1, cbuffer);
	cbuffer.Format(GetResString(IDS_STATS_UNKNOWNCLIENT),myStats[0]);stattree.SetItemText(cli3, cbuffer);
	int32 servtotal;
	int32 servfail;
	int32 servuser;
	int32 servfile;
	int32 servtuser;
	int32 servtfile;
	theApp.serverlist->GetStatus( servtotal, servfail, servuser, servfile, servtuser, servtfile);
	cbuffer.Format(GetResString(IDS_SF_WORKING)+": %i",servtotal-servfail);stattree.SetItemText(srv1, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_FAIL)+": %i",servfail);stattree.SetItemText(srv2, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_TOTAL)+": %i",servtotal);stattree.SetItemText(srv3, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_DELCOUNT)+": %i",theApp.serverlist->GetDeletedServerCount());stattree.SetItemText(srv4, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_WUSER)+": %i",servuser);stattree.SetItemText(srv5, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_WFILE)+": %i",servfile);stattree.SetItemText(srv6, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_USER)+": %i",servtuser);stattree.SetItemText(srv7, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_FILE)+": %i",servtfile);stattree.SetItemText(srv8, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_ACTIVECON)+": %i",activeconnections);stattree.SetItemText(con6, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_MAXCONLIMITREACHED)+": %i",theApp.listensocket->GetMaxConnectionReached());stattree.SetItemText(con7, cbuffer);
	if(theApp.serverconnect->IsConnected()){
		cbuffer.Format(GetResString(IDS_SF_AVGCON)+": %i",(int)averageconnections);stattree.SetItemText(con8, cbuffer);
	}
	else{
		stattree.SetItemText(con8, GetResString(IDS_STATS_WAITCONN));
	}
	cbuffer.Format(GetResString(IDS_SF_PEAKCON)+": %i",peakconnections);stattree.SetItemText(con9, cbuffer);
}

float CStatisticsDlg::GetAvgDownloadRate(int averageType) {
	
	if (averageType==AVG_SESSION) {
		if (theApp.stat_transferStarttime ==0) return 0;

		DWORD running=(GetTickCount()-theApp.stat_transferStarttime)/1000;
		if (running<5) return 0;

		return (float)(theApp.stat_sessionReceivedBytes/1024) / running;
	} else {
		if (downrateHistory.size()==0) return 0;
		uint64 sum=0;
/*
		list<uint64>::iterator walker;
		for(walker = downrateHistory.begin(); walker != downrateHistory.end(); walker++)
			sum+=(*walker);		
*/
		sum=downrateHistory.front();
		if ((uint16)downrateHistory.size()>=(uint16)theApp.glob_prefs->GetStatsAverageMinutes()*60) sum-=downrateHistory.back();

		return (float)(sum/1024)/downrateHistory.size();
	}
}

float CStatisticsDlg::GetAvgUploadRate(int averageType) {
	if (averageType==AVG_SESSION) {
		if (theApp.stat_transferStarttime==0) return 0;

		DWORD running=(GetTickCount()-theApp.stat_transferStarttime)/1000;
		if (running<5) return 0;

		return (float)(theApp.stat_sessionSentBytes/1024) / running;
	} else  {
		if (uprateHistory.size()==0) return 0;
		uint64 sum=0;
/*
		list<float>::iterator walker;
		for(walker = uprateHistory.begin(); walker != uprateHistory.end(); walker++)
			sum+=(*walker);		
*/		
		sum=uprateHistory.front();
		if ((uint16)uprateHistory.size()>=(uint16)theApp.glob_prefs->GetStatsAverageMinutes()*60) sum-=uprateHistory.back();

		return (float)(sum/1024)/uprateHistory.size();
	}

}

void CStatisticsDlg::OnShowWindow(BOOL bShow,UINT nStatus){

}

void CStatisticsDlg::OnSize(UINT nType, int cx, int cy)
{
	CResizableDialog::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here
	//this will cause COScopeCtrl::OnSizeCall
	CRect rc;
	GetDlgItem(IDC_UPLOAD)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	m_DownloadOMeter.MoveWindow(&rc);

}  //OnSize

void CStatisticsDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{

	CSliderCtrl* slider =(CSliderCtrl*)pScrollBar;
	int position = slider->GetPos();
	
	theApp.glob_prefs->SetTrafficOMeterInterval(position);
	ShowInterval(false);

	UpdateData(false); 
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CStatisticsDlg::ShowInterval(bool setSliderPosition) {
	EnableWindow( FALSE );

	if (setSliderPosition) ((CSliderCtrl*)GetDlgItem(IDC_SLIDER))->
		SetPos(theApp.glob_prefs->GetTrafficOMeterInterval());
	
	if (theApp.glob_prefs->GetTrafficOMeterInterval()==0) m_SliderValue.Format(GetResString(IDS_DISABLED));
	else m_SliderValue.Format(GetResString(IDS_STATS_UPDATELABEL), theApp.glob_prefs->GetTrafficOMeterInterval());

	int shownSecs=319*theApp.glob_prefs->GetTrafficOMeterInterval();

	
	if (theApp.glob_prefs->GetTrafficOMeterInterval()==0) {
		m_DownloadOMeter.SetXUnits(GetResString(IDS_STOPPED)); 
		m_UploadOMeter.SetXUnits(GetResString(IDS_STOPPED)); 
	} else
	{
		char buffer[50];
		CastSecondsToHM(shownSecs,buffer);
		m_UploadOMeter.SetXUnits(buffer );
		m_DownloadOMeter.SetXUnits(buffer); 
	}

	UpdateData(FALSE);
	EnableWindow( TRUE );
}

void CStatisticsDlg::SetARange(bool SetDownload,int maxValue){
	if (SetDownload) {
		m_DownloadOMeter.SetRange(0, maxValue+4, 0);
		m_DownloadOMeter.SetRange(0, maxValue+4, 1);
		m_DownloadOMeter.SetRange(0, maxValue+4, 2);
	}else{
		m_UploadOMeter.SetRange(0, maxValue+4, 0) ;
		m_UploadOMeter.SetRange(0, maxValue+4, 1);
		m_UploadOMeter.SetRange(0, maxValue+4, 2);
	}
}

void CStatisticsDlg::Localize(){
	GetDlgItem(IDC_STATIC_D3)->SetWindowText(GetResString(IDS_ST_DOWNLOAD));
	GetDlgItem(IDC_STATIC_U)->SetWindowText(GetResString(IDS_ST_UPLOAD));
	GetDlgItem(IDC_STATIC_D)->SetWindowText(GetResString(IDS_ST_CURRENT));
	GetDlgItem(IDC_STATIC_U2)->SetWindowText(GetResString(IDS_ST_CURRENT));
	GetDlgItem(IDC_STATIC_D2)->SetWindowText(GetResString(IDS_ST_SESSION));
	GetDlgItem(IDC_STATIC_U3)->SetWindowText(GetResString(IDS_ST_SESSION));
	GetDlgItem(IDC_STATIC_S2)->SetWindowText(GetResString(IDS_ST_ACTIVED));
	GetDlgItem(IDC_STATIC_S0)->SetWindowText(GetResString(IDS_ST_ACTIVEC));
	GetDlgItem(IDC_STATIC_S1)->SetWindowText(GetResString(IDS_ST_ACTIVEU));
	GetDlgItem(IDC_STATIC_S3)->SetWindowText(GetResString(IDS_ST_WAITINGU));
	CString value;value.Format(" (%u mins)",theApp.glob_prefs->GetStatsAverageMinutes() );
	GetDlgItem(IDC_TIMEAVG1)->SetWindowText(GetResString(IDS_AVG) + value );
	GetDlgItem(IDC_TIMEAVG2)->SetWindowText(GetResString(IDS_AVG) + value);
}
